searchNodes=[{"doc":"Flop is a helper library for filtering, ordering and pagination with Ecto.UsageDerive Flop.Schema in your Ecto schemas.defmodule Pet do use Ecto.Schema @derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age]} schema &quot;pets&quot; do field :name, :string field :age, :integer field :species, :string field :social_security_number, :string end endValidate a parameter map to get a Flop.t/0 struct with Flop.validate/1. Add the Flop.t/0 to a Ecto.Queryable.t/0 with Flop.query/2.iex&gt; params = %{&quot;order_by&quot; =&gt; [&quot;name&quot;, &quot;age&quot;], &quot;limit&quot; =&gt; 5} iex&gt; {:ok, flop} = Flop.validate(params, for: Flop.Pet) {:ok, %Flop{ filters: [], limit: 5, offset: nil, order_by: [:name, :age], order_directions: nil, page: nil, page_size: nil }} iex&gt; Flop.Pet |&gt; Flop.query(flop) #Ecto.Query&lt;from p0 in Flop.Pet, order_by: [asc: p0.name, asc: p0.age], limit: ^5&gt;Use Flop.validate_and_run/3, Flop.validate_and_run!/3, Flop.run/3, Flop.all/3 or Flop.meta/3 to query the database. Also consult the readme for more details.","ref":"Flop.html","title":"Flop","type":"module"},{"doc":"Applies the given Flop to the given queryable and returns all matchings entries.iex&gt; Flop.all(Flop.Pet, %Flop{}, repo: Flop.Repo) []You can also configure a default repo in your config files:config :flop, repo: MyApp.RepoThis allows you to omit the third argument:iex&gt; Flop.all(Flop.Pet, %Flop{}) []","ref":"Flop.html#all/3","title":"Flop.all/3","type":"function"},{"doc":"Returns the total count of entries matching the filter conditions of the Flop.The pagination and ordering option are disregarded.iex&gt; Flop.count(Flop.Pet, %Flop{}, repo: Flop.Repo) 0You can also configure a default repo in your config files:config :flop, repo: MyApp.RepoThis allows you to omit the third argument:iex&gt; Flop.count(Flop.Pet, %Flop{}) 0","ref":"Flop.html#count/3","title":"Flop.count/3","type":"function"},{"doc":"Applies the filter parameter of a Flop.t/0 to an Ecto.Queryable.t/0.Used by Flop.query/2.","ref":"Flop.html#filter/2","title":"Flop.filter/2","type":"function"},{"doc":"Returns meta information for the given query and flop that can be used for building the pagination links.iex&gt; Flop.meta(Flop.Pet, %Flop{limit: 10}, repo: Flop.Repo) %Flop.Meta{ current_offset: 0, current_page: 1, flop: %Flop{limit: 10}, has_next_page?: false, has_previous_page?: false, next_offset: nil, next_page: nil, page_size: 10, previous_offset: nil, previous_page: nil, total_count: 0, total_pages: 0 }The function returns both the current offset and the current page, regardless of the pagination type. If the offset lies in between pages, the current page number is rounded up. This means that it is possible that the values for current_page and next_page can be identical. This can only occur if you use offset/limit based pagination with arbitrary offsets, but in that case, you will use the previous_offset, current_offset and next_offset values to render the pagination links anyway, so this shouldn't be a problem.","ref":"Flop.html#meta/3","title":"Flop.meta/3","type":"function"},{"doc":"Applies the order_by and order_directions parameters of a Flop.t/0 to an Ecto.Queryable.t/0.Used by Flop.query/2.","ref":"Flop.html#order_by/2","title":"Flop.order_by/2","type":"function"},{"doc":"Applies the pagination parameters of a Flop.t/0 to an Ecto.Queryable.t/0.The function supports both offset/limit based pagination and page/page_size based pagination.If you validated the Flop.t/0 with Flop.validate/1 before, you can be sure that the given Flop.t/0 only has pagination parameters set for one pagination method. If you pass an unvalidated Flop.t/0 that has pagination parameters set for multiple pagination methods, this function will arbitrarily only apply one of the pagination methods.Used by Flop.query/2.","ref":"Flop.html#paginate/2","title":"Flop.paginate/2","type":"function"},{"doc":"Adds clauses for filtering, ordering and pagination to a Ecto.Queryable.t/0.The parameters are represented by the Flop.t/0 type. Any nil values will be ignored.Examplesiex&gt; flop = %Flop{limit: 10, offset: 19} iex&gt; Flop.query(Flop.Pet, flop) #Ecto.Query&lt;from p0 in Flop.Pet, limit: ^10, offset: ^19&gt;Or enhance an already defined query:iex&gt; require Ecto.Query iex&gt; flop = %Flop{limit: 10} iex&gt; Flop.Pet |&gt; Ecto.Query.where(species: &quot;dog&quot;) |&gt; Flop.query(flop) #Ecto.Query&lt;from p0 in Flop.Pet, where: p0.species == &quot;dog&quot;, limit: ^10&gt;","ref":"Flop.html#query/2","title":"Flop.query/2","type":"function"},{"doc":"Applies the given Flop to the given queryable, retrieves the data and the meta data.This function does not validate the given flop parameters. You can validate the parameters with Flop.validate/2 or Flop.validate!/2, or you can use Flop.validate_and_run/3 or Flop.validate_and_run!/3 instead of this function.iex&gt; {data, meta} = Flop.run(Flop.Pet, %Flop{}) iex&gt; data == [] true iex&gt; match?(%Flop.Meta{}, meta) true","ref":"Flop.html#run/3","title":"Flop.run/3","type":"function"},{"doc":"Validates a Flop.t/0.Examplesiex&gt; params = %{&quot;limit&quot; =&gt; 10, &quot;offset&quot; =&gt; 0, &quot;texture&quot; =&gt; &quot;fluffy&quot;} iex&gt; Flop.validate(params) {:ok, %Flop{ filters: [], limit: 10, offset: 0, order_by: nil, order_directions: nil, page: nil, page_size: nil }} iex&gt; flop = %Flop{offset: -1} iex&gt; {:error, changeset} = Flop.validate(flop) iex&gt; changeset.valid? false iex&gt; changeset.errors [ offset: {&quot;must be greater than or equal to %{number}&quot;, [validation: :number, kind: :greater_than_or_equal_to, number: 0]} ]It also makes sure that only one pagination method is used.iex&gt; params = %{limit: 10, offset: 0, page: 5, page_size: 10} iex&gt; {:error, changeset} = Flop.validate(params) iex&gt; changeset.valid? false iex&gt; changeset.errors [limit: {&quot;cannot combine multiple pagination types&quot;, []}]If you derived Flop.Schema in your Ecto schema to define the filterable and sortable fields, you can pass the module name to the function to validate that only allowed fields are used.iex&gt; params = %{&quot;order_by&quot; =&gt; [&quot;species&quot;]} iex&gt; {:error, changeset} = Flop.validate(params, for: Flop.Pet) iex&gt; changeset.valid? false iex&gt; [order_by: {msg, [_, {_, enum}]}] = changeset.errors iex&gt; msg &quot;has an invalid entry&quot; iex&gt; enum [:name, :age]Note that currently, trying to use an existing field that is not allowed as seen above will result in the error message has an invalid entry, while trying to use a field name that does not exist in the schema (or more precisely: a field name that doesn't exist as an atom) will result in the error message is invalid. This might change in the future.","ref":"Flop.html#validate/2","title":"Flop.validate/2","type":"function"},{"doc":"Same as Flop.validate/2, but raises an Ecto.InvalidChangesetError if the parameters are invalid.","ref":"Flop.html#validate!/2","title":"Flop.validate!/2","type":"function"},{"doc":"Validates the given flop parameters and retrieves the data and meta data on success.iex&gt; {:ok, {[], %Flop.Meta{}}} = ...&gt; Flop.validate_and_run(Flop.Pet, %Flop{}, for: Flop.Pet) iex&gt; {:error, %Ecto.Changeset{} = changeset} = ...&gt; Flop.validate_and_run(Flop.Pet, %Flop{limit: -1}) iex&gt; changeset.errors [ limit: {&quot;must be greater than %{number}&quot;, [validation: :number, kind: :greater_than, number: 0]} ]Optionsfor: Passed to Flop.validate/2.repo: The Ecto.Repo module. Required if no default repo is configured.","ref":"Flop.html#validate_and_run/3","title":"Flop.validate_and_run/3","type":"function"},{"doc":"Same as Flop.validate_and_run/3, but raises on error.","ref":"Flop.html#validate_and_run!/3","title":"Flop.validate_and_run!/3","type":"function"},{"doc":"Represents the supported order direction values.","ref":"Flop.html#t:order_direction/0","title":"Flop.order_direction/0","type":"type"},{"doc":"Represents the query parameters for filtering, ordering and pagination.Fieldslimit, offset: Used for pagination. May not be used together with page and page_size.page, page_size: Used for pagination. May not be used together with limit and offset.order_by: List of fields to order by. Fields can be restricted by deriving Flop.Schema in your Ecto schema.order_directions: List of order directions applied to the fields defined in order_by. If empty or the list is shorter than the order_by list, :asc will be used as a default for each missing order direction.filters: List of filters, see Flop.Filter.t/0.","ref":"Flop.html#t:t/0","title":"Flop.t/0","type":"type"},{"doc":"Defines a filter.","ref":"Flop.Filter.html","title":"Flop.Filter","type":"module"},{"doc":"Represents valid filter operators.","ref":"Flop.Filter.html#t:op/0","title":"Flop.Filter.op/0","type":"type"},{"doc":"Represents filter query parameters.Fieldsfield: The field the filter is applied to. The allowed fields can be restricted by deriving Flop.Schema in your Ecto schema.op: The filter operator.value: The comparison value of the filter.","ref":"Flop.Filter.html#t:t/0","title":"Flop.Filter.t/0","type":"type"},{"doc":"Defines a struct for holding meta information of a query result.","ref":"Flop.Meta.html","title":"Flop.Meta","type":"module"},{"doc":"Meta information for a query result.","ref":"Flop.Meta.html#t:t/0","title":"Flop.Meta.t/0","type":"type"},{"doc":"This protocol allows you to define the sortable and filterable fields in your Ecto schemas.UsageDerive Flop.Schema in your Ecto schema.defmodule Flop.Pet do use Ecto.Schema @derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age], max_limit: 20} schema &quot;pets&quot; do field :name, :string field :age, :integer field :species, :string end endAfter that, you can pass the module as the :for option to Flop.validate/2.iex&gt; Flop.validate(%Flop{order_by: [:name]}, for: Flop.Pet) {:ok, %Flop{ filters: [], limit: nil, offset: nil, order_by: [:name], order_directions: nil, page: nil, page_size: nil }} iex&gt; {:error, changeset} = Flop.validate( ...&gt; %Flop{order_by: [:species]}, for: Flop.Pet ...&gt; ) iex&gt; changeset.valid? false iex&gt; changeset.errors [ order_by: {&quot;has an invalid entry&quot;, [validation: :subset, enum: [:name, :age]]} ]Defining default and maximum limitsTo define a default or maximum limit, you can set the default_limit and max_limit option when deriving Flop.Schema. The maximum limit will be validated and the default limit applied by Flop.validate/1.@derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age], max_limit: 100, default_limit: 50}","ref":"Flop.Schema.html","title":"Flop.Schema","type":"protocol"},{"doc":"Returns the default limit of a schema.iex&gt; Flop.Schema.default_limit(%Flop.Fruit{}) 50","ref":"Flop.Schema.html#default_limit/1","title":"Flop.Schema.default_limit/1","type":"function"},{"doc":"Returns the filterable fields of a schema.iex&gt; Flop.Schema.filterable(%Flop.Pet{}) [:name, :species]","ref":"Flop.Schema.html#filterable/1","title":"Flop.Schema.filterable/1","type":"function"},{"doc":"Returns the maximum limit of a schema.iex&gt; Flop.Schema.max_limit(%Flop.Pet{}) 20","ref":"Flop.Schema.html#max_limit/1","title":"Flop.Schema.max_limit/1","type":"function"},{"doc":"Returns the sortable fields of a schema.iex&gt; Flop.Schema.sortable(%Flop.Pet{}) [:name, :age]","ref":"Flop.Schema.html#sortable/1","title":"Flop.Schema.sortable/1","type":"function"},{"doc":"","ref":"Flop.Schema.html#t:t/0","title":"Flop.Schema.t/0","type":"type"},{"doc":"FlopFlop is an Elixir library for making filtering, ordering and pagination with Ecto a bit easier.This library is in early development.","ref":"readme.html","title":"Flop","type":"extras"},{"doc":"ordering by multiple fields in multiple directionsoffset/limit based paginationpage number/page size based paginationfiltering by multiple conditions with diverse operators on multiple fieldsparameter validationconfigurable filterable and sortable fieldsquery and meta data helpers","ref":"readme.html#features","title":"Flop - Features","type":"extras"},{"doc":"Add flop to your list of dependencies in mix.exs:def deps do [ {:flop, &quot;~&gt; 0.6.1&quot;} ] endIf you want to configure a default repo, add this to your config file:config :flop, repo: MyApp.Repo","ref":"readme.html#installation","title":"Flop - Installation","type":"extras"},{"doc":"Define sortable and filterable fieldsIf you want the order by and filter fields to be validated, configure the sortable and filterable fields in your Ecto schema like this:defmodule MyApp.Pet do use Ecto.Schema @derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age, :species]} schema &quot;pets&quot; do field :name, :string field :age, :integer field :species, :string field :social_security_number, :string end endQuery dataYou can use Flop.validate_and_run/3 or Flop.validate_and_run!/3 to validate the Flop parameters, retrieve the data from the database and get the meta data for pagination in one go.defmodule MyApp.Pets do import Ecto.Query, warn: false alias Ecto.Changeset alias Flop alias MyApp.{Pet, Repo} @spec list_pets(Flop.t()) :: {:ok, {[Pet.t()], Flop.Meta.t}} | {:error, Changeset.t()} def list_pets(flop \\\\ %Flop{}) do Flop.validate_and_run(Pet, flop, for: Pet) end endThe for option sets the Ecto schema for which you derived Flop.Schema. If you didn't derive Flop.Schema as described above and don't care to do so, you can omit this option.On success, Flop.validate_and_run/3 returns an :ok tuple, with the second element being a tuple with the data and the meta data.{:ok, {[%Pet{}], %Flop.Meta{}}}Consult the docs for more info on the Meta struct.If you prefer to validate the parameters in your controllers, you can use Flop.validate/2 or Flop.validate!/2 and Flop.run/3 instead.defmodule MyAppWeb.PetController do use MyAppWeb, :controller alias Flop alias MyApp.Pets alias MyApp.Pets.Pet action_fallback MyAppWeb.FallbackController def index(conn, params) do with {:ok, flop} &lt;- Flop.validate(params, for: Pet) do pets = Pets.list_pets(flop) render(conn, &quot;index.html&quot;, pets: pets) end end end defmodule MyApp.Pets do import Ecto.Query, warn: false alias Flop alias MyApp.Pets.Pet alias MyApp.Repo @spec list_pets(Flop.t()) :: {[Pet.t()], Flop.Meta.t} def list_pets(flop \\\\ %Flop{}) do Flop.run(Pet, flop, for: Pet) end endIf you only need the data, or if you only need the meta data, you can also call Flop.all/3, Flop.meta/3 or Flop.count/3 directly.If you didn't configure a default repo as described above or if you want to override the default repo, you can pass it as an option to any function that uses the repo:Flop.run_and_validate(Pet, flop, repo: MyApp.Repo) Flop.all(Pet, flop, repo: MyApp.Repo) Flop.meta(Pet, flop, repo: MyApp.Repo) # etc.","ref":"readme.html#usage","title":"Flop - Usage","type":"extras"},{"doc":"Flop Phoenix is a companion library that defines view helpers for use in Phoenix templates.","ref":"readme.html#flop-phoenix","title":"Flop - Flop Phoenix","type":"extras"}]